# opkhelper
# lib/buildsystem/autoconf
# Build system plugin for GNU Autoconf.
#
# Copyright (C) 2012 Patrick "P. J." McDermott
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

[ -n "${_OH_BUILDSYSTEM_AUTOCONF_SM}" ] && return 0
_OH_BUILDSYSTEM_AUTOCONF_SM='true'

_oh_autoconf_can_configure()
{
	[ -x "${_OH_BUILDSYSTEM_SOURCE_DIR}/configure" ]
}

_oh_autoconf_configure()
{
	mkdir -p "${_OH_BUILDSYSTEM_BUILD_DIR}"
	cd "${_OH_BUILDSYSTEM_BUILD_DIR}"

	"${_OH_BUILDSYSTEM_SOURCE_DIR}/configure" \
		--prefix='/usr' \
		--bindir='${prefix}/bin' \
		--sbindir='${prefix}/sbin' \
		--libexecdir='${prefix}/lib' \
		--sysconfdir='/etc' \
		--localstatedir='/var' \
		--libdir='${prefix}/lib' \
		--includedir='${prefix}/include' \
		--infodir='${prefix}/share/info' \
		--mandir='${prefix}/share/man' \
		--build="${OPK_BUILD_ARCH_GNU}" \
		$([ "${OPK_BUILD_ARCH}" != "${OPK_HOST_ARCH}" ] && \
			printf '%s' "--host=${OPK_HOST_ARCH_GNU}") \
		--disable-maintainer-mode \
		--disable-dependency-tracking \
		"${@}"

	cd "${_OH_BUILDSYSTEM_WORK_AREA}"
}

_oh_autoconf_can_build()
{
	return 1
}

_oh_autoconf_can_clean()
{
	return 1
}

_oh_autoconf_can_test()
{
	return 1
}

_oh_autoconf_can_install()
{
	return 1
}
