#!@@SH@@
#
# opkhelper
# src/oh-autotest
# Automatically run a package's test suites.
#
# Copyright (C) 2012 Patrick "P. J." McDermott
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

. '@@LIBOPKHELPER@@/load.sm'

oh_use buildsystem

main()
{
	oh_init

	while getopts 'S:B:' opt; do
		case "${opt}" in
			S)
				oh_set_buildsystem_option 'build-system' "${OPTARG}"
				;;
			B)
				oh_set_buildsystem_option 'build-dir' "${OPTARG}"
				;;
			?)
				ob_error "$(ob_get_msg 'bad_opt')"
				exit 1
				;;
		esac
	done
	shift $(($OPTIND - 1))

	oh_buildsystems_init

	oh_buildsystem_do 'test' "${@}"
}

main "${@}"
